MyGUI: MyGUI::Canvas Class Reference

MyGUI 3.2.2

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions | Protected Attributes
MyGUI::Canvas Class Reference

Canvas properties.
Skin childs. Widget wrapper over Texture - shows the texture. Implemented: resizing of texture (see TextureResizeMode); recovery after loosing device; More...

`#include <MyGUI_Canvas.h>`

Inheritance diagram for MyGUI::Canvas:
[legend]

## Data Structures
struct | Event

## Public Types
enum | TextureResizeMode { TRM_PT_CONST_SIZE, TRM_PT_VIEW_REQUESTED, TRM_PT_VIEW_ALL }
typedef RTTIBase | Base
typedef Canvas | RTTIBase
typedef delegates::CMultiDelegate1< Canvas * > | EventHandle_CanvasPtr
typedef delegates::CDelegate2< Canvas *, Event > | EventHandle_CanvasPtrEvent
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual const std::string & | getTypeName () const
virtual bool | isType (const std::type_info &_type) const
template<typename Type >
bool | isType () const
| Canvas ()
void | createTexture (TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture. More...
void | createTexture (int _width, int _height, TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture. More...
void | createTexture (const IntSize &_size, TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture. More...
void | destroyTexture ()
| Destroys texture. More...
void | updateTexture ()
| Call user delegate update and removes old texture if it isn't original. More...
void * | lock (TextureUsage _usage=TextureUsage::Write)
| Locks hardware pixel buffer. More...
void | unlock ()
| Unlocks hardware pixel buffer. More...
bool | isLocked () const
| Checks lockness of hardware _pixel buffer. More...
int | getTextureRealWidth () const
| Returns real width of texture. More...
int | getTextureRealHeight () const
| Returns real height of texture. More...
IntSize | getTextureRealSize () const
| Returns real _size of texture. More...
int | getTextureSrcWidth () const
| Returns needed width while creating texture. More...
int | getTextureSrcHeight () const
| Returns needed height while creating texture. More...
IntSize | getTextureSrcSize () const
| Returns needed sizes while creating texture. More...
PixelFormat | getTextureFormat () const
| Returns needed sizes while creating texture. More...
const std::string & | getTextureName () const
| Returns name of the current texture. More...
virtual void | setSize (const IntSize &_value)
virtual void | setCoord (const IntCoord &_value)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
TextureResizeMode | getResizeMode () const
| Returns resize mode. More...
void | setResizeMode (TextureResizeMode _value)
| Sets resize mode of texture. More...
bool | isTextureSrcSize () const
| Checks if the texture has the source (required by user) size, otherwise real texture size are bigger. More...
bool | isTextureCreated () const
| Returns true if the texture was created (and exists), otherwise false. More...
bool | isTextureManaged () const
| Returns true if we own the texture, otherwise false. More...
ITexture * | getTexture () const
| Reurns interface texture. More...
void | setTextureManaged (bool _value)
| Sets the texture managed. More...
Public Member Functions inherited from MyGUI::Widget
template<typename Type >
bool | isType () const
| Widget ()
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
Widget * | createWidgetT (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
template<typename T >
T * | createWidget (WidgetStyle _style, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
virtual void | setPosition (const IntPoint &_value)
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_value)
void | setRealSize (const FloatSize &_value)
void | setRealCoord (const FloatCoord &_value)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget. More...
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _value)
float | getAlpha () const
void | setInheritsAlpha (bool _value)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount ()
Widget * | getChildAt (size_t _index)
Widget * | findWidget (const std::string &_name)
void | findWidgets (const std::string &_name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord ()
Widget * | getClientWidget ()
void | detachFromWidget (const std::string &_layer="")
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, const std::string &_layer="")
void | changeWidgetSkin (const std::string &_skinName)
void | setWidgetStyle (WidgetStyle _style, const std::string &_layer="")
WidgetStyle | getWidgetStyle () const
void | setProperty (const std::string &_key, const std::string &_value)
virtual size_t | _getItemIndex (Widget *_item)
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, const std::string &_skinName, Widget *_parent, ICroppedRectangle *_croppedParent, const std::string &_name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer ()
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (const std::string &_value)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type >
bool | isType () const
template<typename Type >
Type * | castType (bool _throw=true)
template<typename Type >
const Type * | castType (bool _throw=true) const
| IObject ()
virtual | ~IObject ()
Public Member Functions inherited from MyGUI::ICroppedRectangle
| ICroppedRectangle ()
virtual | ~ICroppedRectangle ()
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
| UserData ()
virtual | ~UserData ()
void | setUserString (const std::string &_key, const std::string &_value)
const std::string & | getUserString (const std::string &_key) const
const MapString & | getUserStrings () const
bool | clearUserString (const std::string &_key)
bool | isUserString (const std::string &_key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType >
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType >
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
| WidgetInput ()
virtual | ~WidgetInput ()
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (const std::string &_value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
| SkinItem ()
ISubWidgetText * | getSubWidgetText ()
ISubWidgetRect * | getSubWidgetMain ()
void | _setTextureName (const std::string &_texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
| LayerItem ()
virtual | ~LayerItem ()
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
virtual void | attachItemToNode (ILayer *_layer, ILayerNode *_node)
virtual void | detachFromLayer ()
virtual void | upLayerItem ()
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::ITextureInvalidateListener
virtual | ~ITextureInvalidateListener ()

## Static Public Member Functions
static const std::string & | getClassTypeName ()
static TextureUsage | getDefaultTextureUsage ()
| Returns default GUI texture usage. More...
static PixelFormat | getDefaultTextureFormat ()
| Returns default GUI texture format. More...
Static Public Member Functions inherited from MyGUI::Widget
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static const std::string & | getClassTypeName ()

## Data Fields
EventHandle_CanvasPtr | eventPreTextureChanges
EventHandle_CanvasPtrEvent | requestUpdateCanvas
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
virtual void | shutdownOverride ()
virtual void | initialiseOverride ()
void | _destroyTexture (bool _sendEvent)
| Destroys texture. More...
void | validate (int &_width, int &_height, TextureUsage &_usage, PixelFormat &_format) const
| Update entered parameters according to current texture resize mode(size) and restore (if can) parameters of usage and format from texture. More...
void | createExactTexture (int _width, int _height, TextureUsage _usage, PixelFormat _format)
| Creates the texture itself. More...
bool | checkCreate (int _width, int _height) const
| Checks if we need to create a texture with such sizes. More...
void | resize (const IntSize &_size)
| Calls when resize widget. More...
void | correctUV ()
| Correct texture uv-coordinates. More...
void | frameAdvise (bool _advise)
| For updating once per frame. More...
void | frameEntered (float _time)
| For updating once per frame. More...
virtual void | textureInvalidate (ITexture *_texture)
void | _setUVSet (const FloatRect &_rect)
Protected Member Functions inherited from MyGUI::Widget
virtual | ~Widget ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer, const std::string &_name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point)
virtual void | baseUpdateEnable ()
virtual ILayerItem * | getLayerItemByPoint (int _left, int _top) const
virtual const IntCoord & | getLayerItemCoord () const
template<typename T >
void | assignWidget (T *&_widget, const std::string &_name)
VectorWidgetPtr | getSkinWidgetsByName (const std::string &_name)
void | destroySkinWidget (Widget *_widget)
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
virtual void | setPropertyOverride (const std::string &_key, const std::string &_value)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (const std::string &_state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_node, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Protected Attributes
ITexture * | mTexture
| Current texture. More...
IntSize | mReqTexSize
| Requested bu user sizes. More...
std::string | mGenTexName
| Generated texture name. More...
TextureResizeMode | mTexResizeMode
| Texture resize mode. More...
uint8 * | mTexData
| Saved pointer from last calling lock. More...
bool | mTexManaged
| true if we own the texture (can delete it or replace by another instance), otherwise false More...
bool | mFrameAdvise
| For updating once per frame. True state means updating before next frame starts. More...
bool | mInvalidateData
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin
ICroppedRectangle * | mCroppedParent

## Detailed Description

Canvas properties.
Skin childs. Widget wrapper over Texture - shows the texture. Implemented: resizing of texture (see TextureResizeMode); recovery after loosing device;

Definition at line 21 of file MyGUI_Canvas.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::Canvas::Base

Definition at line 25 of file MyGUI_Canvas.h.

## ◆ EventHandle_CanvasPtr

typedef delegates::CMultiDelegate1<Canvas*> MyGUI::Canvas::EventHandle_CanvasPtr

Definition at line 46 of file MyGUI_Canvas.h.

## ◆ EventHandle_CanvasPtrEvent

typedef delegates::CDelegate2<Canvas*, Event> MyGUI::Canvas::EventHandle_CanvasPtrEvent

Definition at line 47 of file MyGUI_Canvas.h.

## ◆ RTTIBase

typedef Canvas MyGUI::Canvas::RTTIBase

Definition at line 25 of file MyGUI_Canvas.h.

## Member Enumeration Documentation

## ◆ TextureResizeMode

enum MyGUI::Canvas::TextureResizeMode

Available resize and view modes of texture

Remarks
  PT - Power of Two (size)

Enumerator
TRM_PT_CONST_SIZE | Mode when the texture has constant size and stretching on all widget. Remarks The size specified at creation of the texture increases to nearest power of two and doesn't change any more. Texture is always stretched on all widget.
TRM_PT_VIEW_REQUESTED | Mode when texture pixels look as is. Remarks The texture size is always more or equal than the widget size and is equal to a power of two. Note The size specified at creation of the texture is ignored. The texture is automatically recreated if the size of the widget becomes bigger.
TRM_PT_VIEW_ALL | Mode when the texture stretched on all widget and automatically changes the size for nice look. Remarks The mode same as TRM_PT_VIEW_REQUESTED, but the texture is scaled till the size of the widget. Note The size specified at creation of the texture is ignored. The texture is automatically recreated if the size of the widget becomes bigger.

Definition at line 53 of file MyGUI_Canvas.h.

## Constructor & Destructor Documentation

## ◆ Canvas()

MyGUI::Canvas::Canvas | ( |  | ) |

Definition at line 17 of file MyGUI_Canvas.cpp.

## Member Function Documentation

## ◆ _destroyTexture()

void MyGUI::Canvas::_destroyTexture | ( | bool | _sendEvent | ) |
| protected

Destroys texture.

Definition at line 162 of file MyGUI_Canvas.cpp.

## ◆ _setUVSet()

void MyGUI::Canvas::_setUVSet | ( | const FloatRect & | _rect | ) |
| protected

Definition at line 268 of file MyGUI_Canvas.cpp.

## ◆ checkCreate()

bool MyGUI::Canvas::checkCreate | ( | int | _width,
|  | int | _height
| ) |  | const
| protected

Checks if we need to create a texture with such sizes.

Definition at line 117 of file MyGUI_Canvas.cpp.

## ◆ correctUV()

void MyGUI::Canvas::correctUV | ( |  | ) |
| protected

Correct texture uv-coordinates.

Definition at line 177 of file MyGUI_Canvas.cpp.

## ◆ createExactTexture()

void MyGUI::Canvas::createExactTexture | ( | int | _width,
|  | int | _height,
|  | TextureUsage | _usage,
|  | PixelFormat | _format
| ) |  |
| protected

Creates the texture itself.

Definition at line 44 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [1/3]

void MyGUI::Canvas::createTexture | ( | const IntSize & | _size,
|  | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = `getDefaultTextureUsage()`,
|  | PixelFormat | _format = `getDefaultTextureFormat()`
| ) |  |

Creates texture.

Definition at line 36 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [2/3]

void MyGUI::Canvas::createTexture | ( | int | _width,
|  | int | _height,
|  | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = `getDefaultTextureUsage()`,
|  | PixelFormat | _format = `getDefaultTextureFormat()`
| ) |  |

Creates texture.

Definition at line 72 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [3/3]

void MyGUI::Canvas::createTexture | ( | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = `getDefaultTextureUsage()`,
|  | PixelFormat | _format = `getDefaultTextureFormat()`
| ) |  |

Creates texture.

Definition at line 28 of file MyGUI_Canvas.cpp.

## ◆ destroyTexture()

void MyGUI::Canvas::destroyTexture | ( |  | ) |

Destroys texture.

Definition at line 147 of file MyGUI_Canvas.cpp.

## ◆ frameAdvise()

void MyGUI::Canvas::frameAdvise | ( | bool | _advise | ) |
| protected

For updating once per frame.

Definition at line 214 of file MyGUI_Canvas.cpp.

## ◆ frameEntered()

void MyGUI::Canvas::frameEntered | ( | float | _time | ) |
| protected

For updating once per frame.

Definition at line 234 of file MyGUI_Canvas.cpp.

## ◆ getClassTypeName()

static const std::string& MyGUI::Canvas::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 25 of file MyGUI_Canvas.h.

## ◆ getDefaultTextureFormat()

PixelFormat MyGUI::Canvas::getDefaultTextureFormat | ( |  | ) |
| static

Returns default GUI texture format.

Definition at line 364 of file MyGUI_Canvas.cpp.

## ◆ getDefaultTextureUsage()

TextureUsage MyGUI::Canvas::getDefaultTextureUsage | ( |  | ) |
| static

Returns default GUI texture usage.

Definition at line 359 of file MyGUI_Canvas.cpp.

## ◆ getResizeMode()

Canvas::TextureResizeMode MyGUI::Canvas::getResizeMode | ( |  | ) | const

Returns resize mode.

Definition at line 329 of file MyGUI_Canvas.cpp.

## ◆ getTexture()

ITexture * MyGUI::Canvas::getTexture | ( |  | ) | const

Reurns interface texture.

Definition at line 349 of file MyGUI_Canvas.cpp.

## ◆ getTextureFormat()

PixelFormat MyGUI::Canvas::getTextureFormat | ( |  | ) | const

Returns needed sizes while creating texture.

Definition at line 309 of file MyGUI_Canvas.cpp.

## ◆ getTextureName()

const std::string & MyGUI::Canvas::getTextureName | ( |  | ) | const

Returns name of the current texture.

Definition at line 314 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealHeight()

int MyGUI::Canvas::getTextureRealHeight | ( |  | ) | const

Returns real height of texture.

Definition at line 284 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealSize()

IntSize MyGUI::Canvas::getTextureRealSize | ( |  | ) | const

Returns real _size of texture.

Definition at line 289 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealWidth()

int MyGUI::Canvas::getTextureRealWidth | ( |  | ) | const

Returns real width of texture.

Definition at line 279 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcHeight()

int MyGUI::Canvas::getTextureSrcHeight | ( |  | ) | const

Returns needed height while creating texture.

Definition at line 299 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcSize()

IntSize MyGUI::Canvas::getTextureSrcSize | ( |  | ) | const

Returns needed sizes while creating texture.

Definition at line 304 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcWidth()

int MyGUI::Canvas::getTextureSrcWidth | ( |  | ) | const

Returns needed width while creating texture.

Definition at line 294 of file MyGUI_Canvas.cpp.

## ◆ getTypeName()

virtual const std::string& MyGUI::Canvas::getTypeName | ( |  | ) | const
| inlinevirtual

Get type name as string

Reimplemented from MyGUI::Widget.

Definition at line 25 of file MyGUI_Canvas.h.

## ◆ initialiseOverride()

void MyGUI::Canvas::initialiseOverride | ( |  | ) |
| protectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 158 of file MyGUI_Canvas.cpp.

## ◆ isLocked()

bool MyGUI::Canvas::isLocked | ( |  | ) | const

Checks lockness of hardware _pixel buffer.

Definition at line 274 of file MyGUI_Canvas.cpp.

## ◆ isTextureCreated()

bool MyGUI::Canvas::isTextureCreated | ( |  | ) | const

Returns true if the texture was created (and exists), otherwise false.

Definition at line 339 of file MyGUI_Canvas.cpp.

## ◆ isTextureManaged()

bool MyGUI::Canvas::isTextureManaged | ( |  | ) | const

Returns true if we own the texture, otherwise false.

See also
  mManaged

Definition at line 344 of file MyGUI_Canvas.cpp.

## ◆ isTextureSrcSize()

bool MyGUI::Canvas::isTextureSrcSize | ( |  | ) | const

Checks if the texture has the source (required by user) size, otherwise real texture size are bigger.

Definition at line 209 of file MyGUI_Canvas.cpp.

## ◆ isType() [1/2]

template<typename Type >

bool MyGUI::Canvas::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 25 of file MyGUI_Canvas.h.

## ◆ isType() [2/2]

virtual bool MyGUI::Canvas::isType | ( | const std::type_info & | _type | ) | const
| inlinevirtual

Compare with selected type

Reimplemented from MyGUI::Widget.

Definition at line 25 of file MyGUI_Canvas.h.

## ◆ lock()

void * MyGUI::Canvas::lock | ( | TextureUsage | _usage = `TextureUsage::Write` | ) |

Locks hardware pixel buffer.

Definition at line 195 of file MyGUI_Canvas.cpp.

## ◆ resize()

void MyGUI::Canvas::resize | ( | const IntSize & | _size | ) |
| protected

Calls when resize widget.

Definition at line 62 of file MyGUI_Canvas.cpp.

## ◆ setCoord() [1/2]

void MyGUI::Canvas::setCoord | ( | const IntCoord & | _value | ) |
| virtual

Set widget position and size

Reimplemented from MyGUI::Widget.

Definition at line 104 of file MyGUI_Canvas.cpp.

## ◆ setCoord() [2/2]

void MyGUI::Canvas::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height
| ) |  |

See Widget::setCoord(const IntCoord& _coord)

Definition at line 324 of file MyGUI_Canvas.cpp.

## ◆ setResizeMode()

void MyGUI::Canvas::setResizeMode | ( | TextureResizeMode | _value | ) |

Sets resize mode of texture.

See also
  TextureResizeMode

Definition at line 334 of file MyGUI_Canvas.cpp.

## ◆ setSize() [1/2]

void MyGUI::Canvas::setSize | ( | const IntSize & | _value | ) |
| virtual

Set widget size

Reimplemented from MyGUI::Widget.

Definition at line 97 of file MyGUI_Canvas.cpp.

## ◆ setSize() [2/2]

void MyGUI::Canvas::setSize | ( | int | _width,
|  | int | _height
| ) |  |

See Widget::setSize(const IntSize& _size)

Definition at line 319 of file MyGUI_Canvas.cpp.

## ◆ setTextureManaged()

void MyGUI::Canvas::setTextureManaged | ( | bool | _value | ) |

Sets the texture managed.

Remarks
  Be careful with assigning managed status to texture, which wasn't created in Canvas!

See also
  mManaged

Definition at line 354 of file MyGUI_Canvas.cpp.

## ◆ shutdownOverride()

void MyGUI::Canvas::shutdownOverride | ( |  | ) |
| protectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 152 of file MyGUI_Canvas.cpp.

## ◆ textureInvalidate()

void MyGUI::Canvas::textureInvalidate | ( | ITexture * | _texture | ) |
| protectedvirtual

Implements MyGUI::ITextureInvalidateListener.

Definition at line 263 of file MyGUI_Canvas.cpp.

## ◆ unlock()

void MyGUI::Canvas::unlock | ( |  | ) |

Unlocks hardware pixel buffer.

Definition at line 204 of file MyGUI_Canvas.cpp.

## ◆ updateTexture()

void MyGUI::Canvas::updateTexture | ( |  | ) |

Call user delegate update and removes old texture if it isn't original.

Definition at line 111 of file MyGUI_Canvas.cpp.

## ◆ validate()

void MyGUI::Canvas::validate | ( | int & | _width,
|  | int & | _height,
|  | TextureUsage & | _usage,
|  | PixelFormat & | _format
| ) |  | const
| protected

Update entered parameters according to current texture resize mode(size) and restore (if can) parameters of usage and format from texture.

Definition at line 128 of file MyGUI_Canvas.cpp.

## Field Documentation

## ◆ eventPreTextureChanges

EventHandle_CanvasPtr MyGUI::Canvas::eventPreTextureChanges

Event : Notify user texture instance will be changed

See also
  requestUpdateCanvas.
  signature : void method(MyGUI::Canvas* _canvas)

Parameters

  _canvas,which | will be updated

Definition at line 182 of file MyGUI_Canvas.h.

## ◆ mFrameAdvise

bool MyGUI::Canvas::mFrameAdvise
| protected

For updating once per frame. True state means updating before next frame starts.

Definition at line 243 of file MyGUI_Canvas.h.

## ◆ mGenTexName

std::string MyGUI::Canvas::mGenTexName
| protected

Generated texture name.

Definition at line 231 of file MyGUI_Canvas.h.

## ◆ mInvalidateData

bool MyGUI::Canvas::mInvalidateData
| protected

Definition at line 245 of file MyGUI_Canvas.h.

## ◆ mReqTexSize

IntSize MyGUI::Canvas::mReqTexSize
| protected

Requested bu user sizes.

Definition at line 228 of file MyGUI_Canvas.h.

## ◆ mTexData

uint8* MyGUI::Canvas::mTexData
| protected

Saved pointer from last calling lock.

See also
  lock

Definition at line 237 of file MyGUI_Canvas.h.

## ◆ mTexManaged

bool MyGUI::Canvas::mTexManaged
| protected

true if we own the texture (can delete it or replace by another instance), otherwise false

Definition at line 240 of file MyGUI_Canvas.h.

## ◆ mTexResizeMode

TextureResizeMode MyGUI::Canvas::mTexResizeMode
| protected

Texture resize mode.

See also
  TextureResizeMode

Definition at line 234 of file MyGUI_Canvas.h.

## ◆ mTexture

ITexture* MyGUI::Canvas::mTexture
| protected

Current texture.

Definition at line 225 of file MyGUI_Canvas.h.

## ◆ requestUpdateCanvas

EventHandle_CanvasPtrEvent MyGUI::Canvas::requestUpdateCanvas

Event : Texture instance was changed (May be caused by resizing texture or lossing device). User have to update all references to new instance of texture.
signature : void method(MyGUI::Canvas* _canvas, MyGUI::Canvas::Event _event)

Parameters

  _canvas,which | needs to update
  _event |

Definition at line 189 of file MyGUI_Canvas.h.

The documentation for this class was generated from the following files:

- MyGUI_Canvas.h
- MyGUI_Canvas.cpp